using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace BrowserApplication
{
    [ComVisible(true), InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
    public interface BrowserApplicationEvents
    {
        [DispId(0)]
        void SaveDocument();
    }

    [ComVisible(true), ClassInterface(ClassInterfaceType.AutoDispatch), ComSourceInterfaces(typeof(BrowserApplicationEvents))]
    public partial class BrowserAppControl : UserControl
    {
        public delegate void SaveDocumentHandler();
        SaveDocumentHandler saveDocument;

        public event SaveDocumentHandler SaveDocument
        {
            add
            {
                saveDocument += value;
            }
            remove
            {
                saveDocument -= value;
            }
        }

        protected virtual void OnSaveDocument()
        {
            SaveDocumentHandler handler;

            handler = saveDocument;

            if (handler != null)
            {
                saveDocument();
            }
        }

        public BrowserAppControl()
        {
            InitializeComponent();
            browserTextControl1.ButtonBar = browserButtonBar1;
            browserTextControl1.CreateControl();
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OnSaveDocument();
        }
    }
}